<template>
  <div class="container my-5">
    <b-row>
      <b-col cols="12" class="col-sm-5">
        <img :src="product.image" :alt="product.title" class="w-100"/>
      </b-col>
      <b-col>
        <h1 class="mt-2">{{ product.title }}</h1>
        <p>
          <span v-for="n in 5" :key="n">
            <b-icon variant="warning" :icon="starFill(n, product.rating.rate)"></b-icon>
          </span>
          <small class="text-muted"> ({{ product.rating.count }})</small>
        </p>
        <p>{{ product.description }}</p>
        <p><strong class="h3">${{ product.price }}</strong></p>
        <b-button v-on:click="addToCart(product.id)" variant="primary" class="rounded-0">Add to cart</b-button>
        <b-alert
          class="mt-2"
          :show="dismissCountDown"
          dismissible
          variant="primary"
          @dismissed="dismissCountDown=0"
          @dismiss-count-down="countDownChanged"
        >
          <p>The product was added to your cart!</p>
        </b-alert>
      </b-col>
    </b-row>
  </div>
</template>

<script>
import { mapState } from 'vuex'
import { mapFields } from 'vuex-map-fields'

export default {
  name: 'Product',
  data () {
    return {
      dismissSecs: 5,
      dismissCountDown: 0
    }
  },
  computed: {
    ...mapState([
      'products'
    ]),
    ...mapFields([
      'cart'
    ]),
    product () {
      return this.products.find(p => p.id === Number(this.$route.params.id))
    }
  },
  methods: {
    starFill (number, rate) {
      if (rate < (number - 0.9)) {
        return 'star'
      } else if (rate >= (number - 0.9) && rate <= (number - 0.5)) {
        return 'star-half'
      } else {
        return 'star-fill'
      }
    },
    addToCart (id) {
      if (this.cart.some(e => e.productId === id)) {
        /* cart already contains the product */
        const index = this.cart.findIndex(item => item.productId === id)
        this.cart[index].quantity++
      } else {
        this.cart.push({ productId: id, quantity: 1 })
      }
      this.dismissCountDown = this.dismissSecs
    },
    countDownChanged (dismissCountDown) {
      this.dismissCountDown = dismissCountDown
    }
  }
}
</script>
